git-merge-one-file.shon commit Merge http://www.kernel.org/pub/scm/gitk/gitk (56fc631)
   1#!/bin/sh
   2#
   3# Copyright (c) Linus Torvalds, 2005
   4#
   5# This is the git per-file merge script, called with
   6#
   7#   $1 - original file SHA1 (or empty)
   8#   $2 - file in branch1 SHA1 (or empty)
   9#   $3 - file in branch2 SHA1 (or empty)
  10#   $4 - pathname in repository
  11#   $5 - orignal file mode (or empty)
  12#   $6 - file in branch1 mode (or empty)
  13#   $7 - file in branch2 mode (or empty)
  14#
  15# Handle some trivial cases.. The _really_ trivial cases have
  16# been handled already by git-read-tree, but that one doesn't
  17# do any merges that might change the tree layout.
  18
  19case "${1:-.}${2:-.}${3:-.}" in
  20#
  21# Deleted in both or deleted in one and unchanged in the other
  22#
  23"$1.." | "$1.$1" | "$1$1.")
  24        if [ "$2" ]; then
  25                echo "Removing $4"
  26        fi
  27        if test -f "$4"; then
  28                rm -f -- "$4" &&
  29                rmdir -p "$(expr "$4" : '\(.*\)/')" 2>/dev/null
  30        fi &&
  31                exec git-update-index --remove -- "$4"
  32        ;;
  33
  34#
  35# Added in one.
  36#
  37".$2." | "..$3" )
  38        echo "Adding $4"
  39        git-update-index --add --cacheinfo "$6$7" "$2$3" "$4" &&
  40                exec git-checkout-index -u -f -- "$4"
  41        ;;
  42
  43#
  44# Added in both, identically (check for same permissions).
  45#
  46".$3$2")
  47        if [ "$6" != "$7" ]; then
  48                echo "ERROR: File $4 added identically in both branches,"
  49                echo "ERROR: but permissions conflict $6->$7."
  50                exit 1
  51        fi
  52        echo "Adding $4"
  53        git-update-index --add --cacheinfo "$6" "$2" "$4" &&
  54                exec git-checkout-index -u -f -- "$4"
  55        ;;
  56
  57#
  58# Modified in both, but differently.
  59#
  60"$1$2$3" | ".$2$3")
  61        src2=`git-unpack-file $3`
  62        case "$1" in
  63        '')
  64                echo "Added $4 in both, but differently."
  65                # This extracts OUR file in $orig, and uses git-apply to
  66                # remove lines that are unique to ours.
  67                orig=`git-unpack-file $2`
  68                sz0=`wc -c <"$orig"`
  69                diff -u -La/$orig -Lb/$orig $orig $src2 | git-apply --no-add 
  70                sz1=`wc -c <"$orig"`
  71
  72                # If we do not have enough common material, it is not
  73                # worth trying two-file merge using common subsections.
  74                expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
  75                ;;
  76        *)
  77                echo "Auto-merging $4."
  78                orig=`git-unpack-file $1`
  79                ;;
  80        esac
  81
  82        # We reset the index to the first branch, making
  83        # git-diff-file useful
  84        git-update-index --add --cacheinfo "$6" "$2" "$4"
  85                git-checkout-index -u -f -- "$4" &&
  86                merge "$4" "$orig" "$src2"
  87        ret=$?
  88        rm -f -- "$orig" "$src2"
  89
  90        if [ "$6" != "$7" ]; then
  91                echo "ERROR: Permissions conflict: $5->$6,$7."
  92                ret=1
  93        fi
  94        if [ "$1" = '' ]; then
  95                ret=1
  96        fi
  97
  98        if [ $ret -ne 0 ]; then
  99                echo "ERROR: Merge conflict in $4."
 100                exit 1
 101        fi
 102        exec git-update-index -- "$4"
 103        ;;
 104
 105*)
 106        echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
 107        ;;
 108esac
 109exit 1